/*
 * PM - 2017
 * lab0.c
 */

#ifndef F_CPU
#define F_CPU 16000000UL // 16 MHz clock speed
#endif
 
#include <avr/io.h>
#include <util/delay.h>
#include "lcd.h"

#define DELAY_SECVENTA		250
#define NUM_SECVENTE		6


uint8_t XCHANNEL = 0;
uint8_t YCHANNEL = 1;

/* Aprinde led-ul PC0 la apasarea butonului PB0. */
void exemplu(void) {
	/* Setez pinul PB0 ca intrare. */
	DDRB &= ~(1 << PB0);

	/* Activez rezistenta de pull-up pentru pinul PB0. */
	PORTB |= (1 << PB0);

	/* Setez pinul PC0 ca iesire. */
	DDRC |= (1 << PC0);

	/* Sting LED-ul. */
	PORTC &= ~(1 << PC0);

	while (1) {
		/* Daca butonul este apasat. */
		if ((PINB & (1 << PB0)) == 0)
			/* Aprind LED-ul. */
			PORTC |= (1 << PC0);
		else
			/* Sting LED-ul. */
			PORTC &= ~(1 << PC0);
	}
}

void ceva_simplu() {
	//_delay_ms(50);
	//LCD_init();
	DDRD &= ~( 1 << PD6);
	DDRD |= ( 1 << PD7);
	while(1) {
		if((PIND & (1 << PD6)) == 0) {
			PORTD |= ( 1 << PD7);
			LCD_putCharAt(0,'c');
		}
		else {
			PORTD &= ~( 1 << PD7);
		}
	}

	/*DDRD &= ~( 1 << PD6);
	DDRD |= ( 1 << PD7);


	while(1) {
		if((PIND & (1 << PD6)) == 0) {
			PORTD |= ( 1 << PD7);
		}
		else {
			PORTD &= ~( 1 << PD7);
		}
	}*/
}

void ADC_stop(){					// FUNCTIA DE STOP A ADC-ULUI. VA FI FOLOSITA IN MAIN
	ADCSRA = 0;
}


int ADC_get(uint8_t channel)		// FUNCTIE DE CITIRE DE LA ADC ( COPIATA DIN LAB 6 )
{
	ADMUX = 0;
	ADMUX |= (1 << REFS0);
	ADMUX |= (channel << MUX0);
	ADCSRA |= (1 << ADSC);         //start conversion
	loop_until_bit_is_set(ADCSRA, ADIF);  //wait until conversion is done: until ADIF from ADCSRA is set to 1
	unsigned int value = ADC;
	
	return value;
}
	/*ADMUX &= 0xE0;
	
	ADMUX |= channel;
	ADCSRA |= _BV(ADEN)|_BV(ADSC);
	while(!(ADCSRA & (1<<ADIF)));

	return ADC;
}*/


void ADC_init(void)					// FUNCTIE DE INITIALIZARE A ADC ( COPIATA DIN LAB 6 )
{
	// AVCC cu condesator pe AREF; PA7 ca input single ended; rezultat left-adjusted (8 biti de date)
	ADMUX = (1<<REFS0);
	
	// activeaza ADC . Prescaler de ceas la maximum
	ADCSRA = (1<<ADEN) | (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0);

}


int main() {

	LCD_init();

	DDRD &= ~( 1 << PD6);
	DDRD |= ( 1 << PD7);

	ADC_init();

	DDRC &= ~( 1 << PA0);
	DDRC &= ~( 1 << PA1);
	DDRC &= ~( 1 << PA2);
	DDRC &= ~( 1 << PA3);
	DDRC &= ~( 1 << PA4);


	int xval = 0;	// INITIALIZARE VARIABILA PENTRU CITIRE DE LA ADC PE AXA X
	int yval = 0;	// INITIALIZARE VARIABILA PENTRU CITIRE DE LA ADC PE AXA Y
	
	int zar11 = 0;
	char aux[16];
	memset(aux, 0, 16);

	while(1){
		xval = ADC_get(XCHANNEL);	// CITIRE VALOARE ADC PENTRU X
		yval = ADC_get(YCHANNEL);	// CITIRE VALOARE ADC PENTRU Y
		
		while( ((xval > 300) && (xval < 500)) || ((yval > 300) && (yval < 500)) )	// ATAT TIMP CAT ZARUL SE AMESTECA
		{ 
			xval = ADC_get(XCHANNEL);			// SE CITESTE VALOARE PENTRU Y
		  	yval = ADC_get(YCHANNEL);			// SE CITESTE VALOARE PENTRU X
			PORTD |= ( 1 << PD7);
			_delay_ms(100);
		}
				
		PORTD &= ~( 1 << PD7);
		ADC_stop();			// OPRESTE CITIREA DE PE ADC

				
		zar11 = xval%6+1;	// GENERARE ZAR RANDOM PENTRU ZARUL 1
		sprintf(aux, "Rolled : %d", zar11);

		LCD_printAt(0, aux);

		_delay_ms(2000);

		ADC_init();


	}

	return 0;
}